#!/usr/bin/env python3
# -*- coding: UTF-8 -*-

import sys
import os
from os import path

# Fonctionne avec Python version 3 et Python 2.7
if sys.version_info.major != 3 and (sys.version_info.major == 2 and sys.version_info.minor != 7):
    print("Vous devez utiliser python 3 ou python 2.7")
    exit(1)

if sys.version_info.major == 2:
    reload(sys)
    sys.setdefaultencoding('utf8')

progname = path.basename(path.splitext(sys.argv[0])[0]).split('_')[0]

Version = '0.19d'
About = "\n"
About += "\n"
About += progname + " version " + str(Version) + "\n"
About += "\n" 
About += " Développé par JoeKer, avec l'aide de différents membres de FONO,\n"
About += " dont particulièrement :\n"
About += " - shdf, auteur de 'Liveboxinfo'(1), dont " + progname + " est un assez fidèle portage en Python.\n"
About += " - crabman et kikito, que je remercie pour leurs participations constructives.\n"
About += " - Markco, dont les déboires avec Wine m'ont convaincu de la nécessité de cet outil !\n"
About += "\n"
About += " Beaucoup de fonctions sont issues d'autres outils, notamment :\n"
About += " - fccagou/pylivebox (https://github.com/fccagou/pylivebox)\n"
About += " - rene-d/sysbus (https://github.com/rene-d/sysbus)\n"
About += "\n"
About += " Testé avec LiveBox 3 et LiveBox 2,\n"
About += "   fonctionne avec les LiveBox 4, mais pas testé par moi-même.\n"
About += "\n"
About += "\n"
About += " Ce programme a été développé et testé avec Python 3.4, et testé avec Python 2.7\n"
About += "\n"
About += " La version que vous exécutez est une version portable,\n" 
About += " compilée en 32 bits pour une meilleure portabilité.\n"
About += "\n\n\n"
About += " (1) Lien vers Liveboxinfo : http://www.liveboxinfo.tk/\n"

import json
import requests
import time
import re

try:
    import tkinter
    from tkinter import *
    from tkinter import ttk
    from tkinter import Tk
    from tkinter import messagebox
    from tkinter import scrolledtext

except:
    import Tkinter
    from Tkinter import *
    from Tkinter import Tk
    import tkMessageBox as messagebox
    import ttk
    import ScrolledText as scrolledtext


VERSION_LIVEBOX = 'auto'
USER_LIVEBOX = 'admin'
URL_LIVEBOX = 'http://192.168.1.1'
PASSWORD = ''
QUOTINGS =[
        ("Balises quote", "quote"),
        ("Balises code", "code"),
    ]
DEBUG_CHOICES =[
        ("Actif  ", "oui"),
        ("Inactif", "non"),
    ]
QUOTING = 'quote'
DEBUGGING = 'non'
sah = 'undef'

VERSIONS_LIVEBOX = [
        ("Déterminer", "auto"),
        ("Livebox  2", "lb2"),
        ("Livebox  3", "lb3"),
        ("Livebox  4", "lb4"),
        (" Inconnu  ", "inconnu")
    ]

def init_version(url):
    global sah
    try:
        r = requests.get(url, timeout=2)
    except Exception as err:
        return 'erreur'
    t = r.text
    a = re.findall(r'BUILD_PROJECT:[^,]*',t)
    d = re.sub(r'.*(lb[0-9a-zA-Z]*).*', r'\1', str(a))
    if d == 'lbv2fr':
        version = 'lb2'
        sah = str(d)
    elif d == 'lbv3fr':
        version = 'lb3'
        sah = str(d)
    elif d == 'lbv4fr':
        version = 'lb4'
        sah = str(d)
    else:
    # Dans le doute en attendant un test réel, on ne bloque pas
        try:
            a = re.findall(r'sah=[a-zA-Z0-9\.]*',t)
        except Exception as err:
            return 'erreur'
        if len(a) > 0:
            b = re.sub(r'.*=(.*)', r'\1', a[0])
            sah = str(b)
            version = 'lb4'
        else:
            version = 'inconnu'
            sah = 'Undef'
    del(d)
    del(a)
    del(t)
    del(r)
    return version

def resource_path(relative_path):
    try:
        base_path = sys._MEIPASS
    except Exception:
        base_path = os.path.abspath(".")
    return os.path.join(base_path, relative_path)
    
class Logins(object):
    global VERSION_LIVEBOX
    version = VERSION_LIVEBOX
    url = URL_LIVEBOX
    user = USER_LIVEBOX
    password = PASSWORD
    quoting = QUOTING
    debugging = DEBUGGING

    def set_version(self, version):
        VERSION_LIVEBOX = version
        self.version = version

    def set_url(self, url):
        self.url = url

    def set_user(self, user):
        self.user = user

    def set_password(self, password):
        self.password = password
    
    def set_quoting(self, quoting):
        QUOTING = quoting
        self.quoting = quoting
    
    def set_debugging(self, debugging):
        DEBUGGING = debugging
        self.debugging = debugging

    def get_version(self):
        return self.version
    
    def get_url(self):
        return self.url

    def get_user(self):
        return self.user

    def get_password(self):
        return self.password
        
    def get_quoting(self):
        return self.quoting
        
    def get_debugging(self):
        return self.debugging
        
    def read(self):
        try:
            f = open("lbinfo.conf", "r")
        except Exception as err: 
            return False
        else:
            data = f.readlines()
            f.close()
            for var in data:
                if var.startswith("version:"):
                    self.version = var.replace("version:", "").strip()
                elif var.startswith("url:"):
                    self.url = var.replace("url:", "").strip()
                elif var.startswith("user:"):
                    self.user = var.replace("user:", "").strip()
                elif var.startswith("password:"):
                    self.password = var.replace("password:", "").strip()
                elif var.startswith("quoting:"):
                    self.quoting = var.replace("quoting:", "").strip()
                elif var.startswith("debugging:"):
                    self.debugging = var.replace("debugging:", "").strip()
            del data
        return True
        
    def save(self):
        try:
            f = open("lbinfo.conf", "w")
        except Exception as err:
            return False
        else:
            f.write("version:%s\n" % self.version)
            f.write("url:%s\n" % self.url)
            f.write("user:%s\n" % self.user)
            f.write("password:%s\n" % self.password)
            f.write("quoting:%s\n" % self.quoting)
            f.write("debugging:%s\n" % self.debugging)
            f.close()
        return True


class Livebox:

    def __init__(self, url_prefix, version_livebox):
        self._url_prefix = url_prefix
        self.version_livebox = version_livebox

    def login(self, user_livebox, password):
        session = requests.Session()
        
        url_login = "%s/authenticate?username=admin&password=%s" % (self._url_prefix, password)

        values = {'username':'admin', 'password':password }
        if self.version_livebox != 'lb3' and self.version_livebox != 'lb4':
            # On est probablement sur l'ancienne méthode d'authentification (avant décembre 2016)
            auth = { 'username':user_livebox, 'password':password }
            sah_headers = {'Content-Type':'application/json'}
            try:
                r = session.post(self._url_prefix + '/authenticate', params=auth, headers=sah_headers, timeout=10)
            except Exception as err:
                messagebox.showerror('Erreur', 'La LiveBox ne répond pas.')
                return False
        else:
            # Cette méthode fonctionne avec les firmwares récents (fin décembre 2016) de la LB3 et de la LB4
            auth = '{"service":"sah.Device.Information","method":"createContext","parameters":{"applicationName":"so_sdkut","username":"%s","password":"%s"}}' % (user_livebox, password)
            sah_headers = { 'Content-Type':'application/x-sah-ws-1-call+json', 'Authorization':'X-Sah-Login' }
            try:
                r = session.post(self._url_prefix + '/ws', data=auth, headers=sah_headers, timeout=10)
            except Exception as err:
                messagebox.showerror('Erreur', 'La LiveBox ne répond pas.')
                return False
        try:
            reponse = r.json()
        except Exception as err:
            reponse = r.json

        try:
            if not 'data' in reponse:
                messagebox.showerror('Erreur', "La LiveBox ne reconnaît pas cette méthode d'authentification, essayer avec un autre modèle de LiveBox dans 'Paramètres'.")
                return False
            elif not 'contextID' in reponse['data']:
                messagebox.showerror('Erreur', "L'authentification a échoué, vérifier le mot de passe.")
                return False
        except Exception as err:
            messagebox.showerror('Erreur', "L'équipement n'est pas reconnu comme une LiveBox.\nreponse contient : " + str(reponse) + "\nErr contient : " + str(err))
            return False

        self._lb_id=r.headers['Set-Cookie']
        self._sessid=(r.headers['Set-Cookie'].split('=',1)[1]).rsplit(';',1)[0]

        self._context_id=reponse['data']['contextID']
        return True

    def _sysbus(self,question):
        return self._request("%s/sysbus/%s" % (self._url_prefix,question), '{"parameters":{}}' )

    def _sysbus_get(self,question):
        return self._request_get("%s/sysbus/%s" % (self._url_prefix,question))

    def _ws(self, params):
        return self._request("%s/ws" % (self._url_prefix), params , 'application/x-sah-ws-4-call+json')

    def _request(self,url, params, content_type='application/json'):
        sah_headers = { 'Content-Type':content_type, 'Cookie':self._lb_id, 'X-Context':self._context_id, 'X-Sah-Request-Type':'idle', 'X-Requested-With':'XMLHttpRequest' }
        r = requests.post(url, data=params, headers=sah_headers)
        try:
            resp = r.json()
        except Exception as err:
            resp = r.json
        return resp

    def _request_get(self,url, content_type='application/json'):
        sah_headers = { 'Content-Type':content_type, 'Cookie':self._lb_id, 'X-Context':self._context_id, 'X-Sah-Request-Type':'idle', 'X-Requested-With':'XMLHttpRequest' }
        r = requests.get(url, headers=sah_headers)
        c = r.text
        d   = c.replace('true', '"true"').replace('false', '"false"')
        data = eval(d)
        o ={}
        for i in range(len(data['parameters'])):
            o.update({str(data['parameters'][i]['name']):str(data['parameters'][i]['value'])})
        return o

    def logout(self):
        sah_headers = { 'Content-Type':"application/x-www-form-urlencoded", 'Cookie':self._lb_id, 'X-Context':self._context_id, 'X-Sah-Request-Type':'idle', 'X-Requested-With':'XMLHttpRequest' }
        r = requests.get("%s/logout" % (self._url_prefix), headers=sah_headers)
        return ""
    
    def voip_config(self):
        j = self._ws('{"service":"NMC","method":"getVoIPConfig","parameters":{}}')
        return j

    def list_trunks(self):
        '''Information téléphonie IP'''
        j = self._sysbus('VoiceService/VoiceApplication:listTrunks')
        return j['result']

    def ip_tv_status(self):
        '''Etat IP TV'''
        return self._sysbus('NMC/OrangeTV:getIPTVStatus')

    def device_info(self):
        ''' Infos device '''
        if self.version_livebox != 'lb3' and self.version_livebox != 'lb4':
            j = self._sysbus_get('DeviceInfo?_restDepth=-1')
            result = j 
            return result
        else:
            j = self._ws('{"service":"DeviceInfo","method":"get","parameters":{}}')
            return j['status']

    def account(self):
        try:
            if self.version_livebox != 'lb3' and self.version_livebox != 'lb4':
                j = self._sysbus_get('NMC?_restDepth=-1')
                result = j
                return result
            else:
                j = self._ws('{"service":"NMC","method":"get","parameters":{}}')
                return j['status']
        except Exception as err:
            messagebox.showerror('Erreur', "Impossible de récupérer les informations de compte Internet.")
            return 'erreur'
        
    def DSLStats(self):
        '''Information lien dsl'''
        j = self._ws('{"service":"NeMo.Intf.dsl0","method":"getDSLStats","parameters":{}}')
        return j['status']

    def dsl_mibs(self):
        j = self._ws('{"service":"NeMo.Intf.dsl0","method":"getMIBs","parameters":{"mibs":"dsl","flag":"","traverse":"down"}}')
        return j['status']

    def dhcp_mibs(self):
        j = self._ws('{"service":"NeMo.Intf.data","method":"getMIBs","parameters":{"mibs":"dhcp"}}')
        return j['status']

    def wifi_com_status(self):
        '''Information Wifi public Orange)'''
        return self._sysbus('Wificom/OpenMode:getStatus')

    def wifi_mibs(self):
        '''Information Wifi'''
        j = self._ws('{"service":"NeMo.Intf.lan","method":"getMIBs","parameters":{"mibs":"wlanvap || wlanradio"}}')
        return j['status']

    def wan_status(self):
        '''Etat de la connexion WAN'''
        j = self._ws('{"service":"NMC","method":"getWANStatus","parameters":{}}')
        return j['data']

    def orange_services(self):
        j = self._ws(str('{"service":"OrangeServices","method":"getSubscriptionStatus","parameters":{"refresh":true}}'))
        return j

    def mtu(self):
        j = self._ws('{"service":"NeMo.Intf.data","method":"getFirstParameter","parameters":{"name":"MTU"}}')
        return j['status']

    def vlan_id(self):
        j = self._ws('{"service":"NeMo.Intf.data","method":"getFirstParameter","parameters":{"name":"VLANID"}}')
        return j['status']

    def ws_channel_id(self):
        j = self._ws('{"events":[{"handler":"sah.hgw.models"}]}')
        return j['channelid']

    def ws_get_devices(self, channel_id):
        j = self._ws('{"events":[{"handler":"sah.hgw.models"}],"channelid":%s}' % channel_id)
        return j


class Interface():
    def __init__(self):
        self.logged = Logins()
        
        FlagConf = self.logged.read()
        wwidth='800'
        wheight='800'
        self.windows = Tk()
        self.windows.title("Données LiveBox")
        self.windows.geometry(wwidth + 'x' + wheight)
        self.windows.option_add('*Dialog.msg.font', 'Courier 10')
        s = ttk.Style()
        s.configure('Tab', background='white', foreground='blue')
        s.configure('Text', background='white')
        s.configure('Text', font = "Courier")
        self.notebook = ttk.Notebook(self.windows)
        
        # parametres généraux
        self.frame_params = ttk.Frame(style='Tab', borderwidth = 2)
        self.frame_params.pack(fill=BOTH, padx=10, pady=10.0, expand=1)
        self.notebook.add(self.frame_params, text='Paramètres')
        
        # Paramètres LiveBox
        self.frame_params_LB = ttk.Frame(self.frame_params, width = int(wwidth), height = int(wheight)/2)
        self.frame_params_LB.pack(side = TOP, anchor=N, expand=1, fill = BOTH)
        # Frame version
        self.frame_params_ver = ttk.Frame(self.frame_params_LB, width = int(wwidth)/4, height = (int(wheight)/2)-2, borderwidth = 2)
        self.frame_params_ver.pack(side = LEFT, anchor=N, expand=1, fill = BOTH)
        # version livebox
        self.label_version = Label(self.frame_params_ver, text=("Version Livebox"))
        self.label_version.pack(pady=10.0)
        
        #VERSIONS_LIVEBOX
        self.version = StringVar()
        self.version.set(self.logged.get_version())

        for text, mode in VERSIONS_LIVEBOX:
            self.radio_version = Radiobutton(self.frame_params_ver, text=text, variable=self.version, value=mode, command=self.set_version_livebox)
            self.radio_version.config()
            self.radio_version.pack(anchor=N)
        
        # Frame Connexion
        self.frame_params_cnx = ttk.Frame(self.frame_params_LB, width = int(wwidth)/4, height = (int(wheight)/2)-2, borderwidth = 2)
        self.frame_params_cnx.pack(side = RIGHT, anchor=N, expand=1, fill = BOTH)
        
        self.label_separator = Label(self.frame_params_LB, text=(""))
        self.label_separator.config()
        self.label_separator.pack(pady=5.0)
        
        #url livebox
        self.label_url = Label(self.frame_params_cnx, text=("URL Livebox"))
        self.label_url.pack()
        self.entry_url = Entry(self.frame_params_cnx)
        self.entry_url.pack(pady=10.0)
        self.entry_url.delete(0, END)
        self.entry_url.insert(0, self.logged.get_url())
        
        # user
        self.label_user = Label(self.frame_params_cnx, text=("User"))
        self.label_user.pack()
        self.entry_user = Entry(self.frame_params_cnx)
        self.entry_user.pack(pady=10.0)
        self.entry_user.delete(0, END)
        self.entry_user.insert(0, self.logged.get_user())
        
        # password
        self.label_password = Label(self.frame_params_cnx, text=("Password"))
        self.label_password.pack()
        self.entry_password = Entry(self.frame_params_cnx, show="*")
        self.entry_password.pack(pady=10.0)
        self.entry_password.delete(0, END)
        self.entry_password.insert(0, self.logged.get_password())
        
        self.label_separator2 = Label(self.frame_params_cnx, text=(""))
        self.label_separator2.config()
        self.label_separator2.pack(pady=5.0)
        
        
        # Frame posting
        self.frame_params_post = ttk.Frame(self.frame_params, width = int(wwidth), height = int(wheight)/2)
        self.frame_params_post.pack(anchor=S, expand=1, fill = BOTH)
        # rubrique quoting
        self.frame_params_quot = ttk.Frame(self.frame_params_post, width = int(wwidth)/4, height = (int(wheight)/2)-2, borderwidth = 2)
        self.frame_params_quot.pack(side = LEFT, anchor=N, expand=1, fill=BOTH)
        self.label_quoting = Label(self.frame_params_quot, text=("Méthode de citation"))
        self.label_quoting.pack()
        
        # Quoting 
        self.quoting = StringVar()
        self.quoting.set(self.logged.get_quoting())

        for libelle, quoting in QUOTINGS:
            self.radio_quoting = Radiobutton(self.frame_params_quot, text=libelle, variable=self.quoting, value=quoting, command=self.set_quoting_livebox)
            self.radio_quoting.config()
            self.radio_quoting.pack(anchor=N)
        
        # Rubrique debugging
        self.frame_params_dbg = ttk.Frame(self.frame_params_post, width = int(wwidth)/4, height = (int(wheight)/2)-2, borderwidth = 2)
        self.frame_params_dbg.pack(side = RIGHT, anchor=N, expand=1, fill=BOTH)
        self.label_debugging = Label(self.frame_params_dbg, text=("Mode debug"))
        self.label_debugging.pack()
        
        # Debugging
        self.debugging = StringVar()
        self.debugging.set(self.logged.get_debugging())

        for libelle, debugging in DEBUG_CHOICES:
            self.radio_debugging = Radiobutton(self.frame_params_dbg, text=libelle, variable=self.debugging, value=debugging, command=self.set_debugging_livebox)
            self.radio_debugging.config()
            self.radio_debugging.pack(anchor=N)
        
        self.label_separator3 = Label(self.frame_params_dbg, text=(""))
        self.label_separator3.config()
        self.label_separator3.pack(pady=5.0)
        
        # Frame buttons
        self.frame_params_buttons = ttk.Frame(self.frame_params, width = int(wwidth), height = 20 )
        self.frame_params_buttons.pack(expand=1, fill = BOTH)
        
        self.frame_params_lbuttons = ttk.Frame(self.frame_params_buttons, width = int(wwidth)/4, height = 20 )
        self.frame_params_lbuttons.pack(expand=0, fill = NONE)
        
        button_savelogins = Button(self.frame_params_lbuttons, text="Enregistrer la configuration", command=self.savelogin)
        button_savelogins.pack(side=LEFT, pady=10.0, padx=20, expand = 0)
        
        button_launch = Button(self.frame_params_lbuttons, text="Extraire les données", command=self.update)
        button_launch.pack(side=RIGHT,pady=10.0, padx=20, expand = 0)
        
        self.photo = PhotoImage(file=resource_path("gif/AUTO.gif"))
        self.fond = Canvas(self.frame_params,width=700,height=200)
        self.fond.create_image(350,70,image=self.photo,anchor=CENTER)
        self.fond.pack(fill=BOTH, expand=1) 
        # /parametres
        
        # creation des infos
        # frames DeviceInfo
        self.frame_DeviceInfo = ttk.Frame()
        self.frame_DeviceInfo.pack(fill=BOTH, expand=1)
        self.text_DeviceInfo = Text(self.frame_DeviceInfo, state=NORMAL)
        self.text_DeviceInfo.config(state=DISABLED)
        self.text_DeviceInfo.pack(fill=BOTH, expand=1)
        
        # frames WanStatus
        self.frame_WanStatus = ttk.Frame()
        self.frame_WanStatus.pack(fill=BOTH, expand=1)
        self.text_WanStatus = Text(self.frame_WanStatus, state=NORMAL)
        self.text_WanStatus.config(state=DISABLED)
        self.text_WanStatus.pack(fill=BOTH, expand=1)
        
        # frames VoipConfig
        self.frame_VoipConfig = ttk.Frame()
        self.frame_VoipConfig.pack(fill=BOTH, expand=1)
        self.text_VoipConfig = Text(self.frame_VoipConfig, state=NORMAL)
        self.text_VoipConfig.config(state=DISABLED)
        self.text_VoipConfig.pack(fill=BOTH, expand=1)
        
        # frames Wi-Fi
        self.frame_WiFi = ttk.Frame()
        self.frame_WiFi.pack(fill=BOTH, expand=1)
        self.text_WiFi = Text(self.frame_WiFi, state=NORMAL)
        self.text_WiFi.config(state=DISABLED)
        self.text_WiFi.pack(fill=BOTH, expand=1)
        
        # frames DSLStats
        self.frame_DSLStats = ttk.Frame()
        self.frame_DSLStats.pack(fill=BOTH, expand=1)
        self.text_DSLStats = Text(self.frame_DSLStats, state=NORMAL)
        self.text_DSLStats.config(state=DISABLED)
        self.text_DSLStats.pack(fill=BOTH, expand=1)
        
        # frames IPTVStatus
        self.frame_IPTVStatus = ttk.Frame()
        self.frame_IPTVStatus.pack(fill=BOTH, expand=1)
        self.text_IPTVStatus = Text(self.frame_IPTVStatus, state=NORMAL)
        self.text_IPTVStatus.config(state=DISABLED)
        self.text_IPTVStatus.pack(fill=BOTH, expand=1)
        
        # frames all
        self.frame_all = ttk.Frame(style='Tab')
        self.frame_all.pack(fill=BOTH, expand=1)
        self.text_all = scrolledtext.ScrolledText(self.frame_all, state=NORMAL)
        self.text_all.pack(fill=BOTH, expand=1)
        self.text_all.config(state=DISABLED)
        button_saveinfo = Button(self.frame_all, text="Enregistrer", command=self.saveinfo)
        button_saveinfo.pack()
        
        # frames FONO
        self.frame_FONO = ttk.Frame()
        self.frame_FONO.pack(fill=BOTH, expand=1)
        self.text_FONO = scrolledtext.ScrolledText(self.frame_FONO, state=NORMAL)
        self.text_FONO.config(state=DISABLED)
        self.text_FONO.pack(fill=BOTH, expand=1)
        button_clipboard = Button(self.frame_FONO, text="Publication", command=self.copy_clipboard)
        button_clipboard.pack()
        
        # frames DEBUG
        self.frame_DEBUG = ttk.Frame()
        self.frame_DEBUG.pack(fill=BOTH, expand=1)
        self.frame_DEBUG_buttons = ttk.Frame(self.frame_DEBUG,width = 80, height = 12)
        self.frame_DEBUG_buttons.pack(side = BOTTOM, expand=0)
        self.text_DEBUG = scrolledtext.ScrolledText(self.frame_DEBUG, state=NORMAL)
        self.text_DEBUG.config(state=DISABLED)
        self.text_DEBUG.pack(fill=BOTH, expand=1)
        dbg_button_saveinfo = Button(self.frame_DEBUG_buttons, text="Sauvegarde dans fichier", command=self.savedbg)
        dbg_button_clipboard = Button(self.frame_DEBUG_buttons, text="Copier pour publier  ", command=self.copy_debug_clipboard)
        dbg_button_saveinfo.pack(side=RIGHT, padx=10)
        dbg_button_clipboard.pack(side=LEFT, padx=10)
        
        # Frame About
        self.frame_About = ttk.Frame()
        self.frame_About.pack(fill=BOTH, expand=1)
        self.text_About = Text(self.frame_About, state=NORMAL)
        self.text_About.tag_config('tag_center', justify = 'center')
        self.text_About.tag_config('tag_italic', font = '8')
        self.text_About.tag_config('tag_bold', foreground ='blue', font = 'bold')
        self.text_About.tag_add('tag_center', 1.0, 'end')
        self.text_About.config(state=DISABLED)
        self.text_About.pack(fill=BOTH, expand=1)
        
        self.notebook.add(self.frame_DeviceInfo, text='DeviceInfo')
        self.notebook.add(self.frame_WanStatus, text='WANStatus')
        self.notebook.add(self.frame_VoipConfig, text='VoipConfig')
        self.notebook.add(self.frame_WiFi, text='Wi-Fi')
        self.notebook.add(self.frame_DSLStats, text='DSLStats')
        self.notebook.add(self.frame_IPTVStatus, text='IPTVStatus')
        self.notebook.add(self.frame_all, text='Tout')
        self.notebook.add(self.frame_FONO, text='Publication forum')
        self.notebook.add(self.frame_DEBUG, text='Debug')
        self.notebook.hide(self.frame_DEBUG)
        self.notebook.add(self.frame_About, text='About')
        self.notebook.pack(fill=BOTH, expand=1)

        self.text_About.config(state=NORMAL)
        self.text_About.delete('1.0', END)
        self.text_About.insert(INSERT, About)
        lpn = len(progname) + 1
        self.text_About.tag_add('tag_center', '1.0', '4.0')
        self.text_About.tag_add('tag_bold', '3.0', '3.'+ str(lpn))
        self.text_About.tag_add('tag_bold', '5.15', '5.22')
        self.text_About.tag_add('tag_bold', '7.3', '7.7')
        self.text_About.tag_add('tag_bold', '8.3', '8.10')
        self.text_About.tag_add('tag_bold', '8.14', '8.20')
        self.text_About.tag_add('tag_bold', '9.3', '9.9')
        self.text_About.config(state=DISABLED)
        
        # Signaler l'absence de fichier de configuration
        if not FlagConf:
            self.windows.option_add('*Dialog.msg.width', 80)
            self.windows.option_add("*Dialog.msg.wrapLength", "7i")
            messagebox.showinfo('Info', "Le fichier de configuration n'existe pas.\n\nPour ne plus afficher ce message, enregistrez la configuration une fois,\n même sans renseigner le mot de passe.\nVous pourrez toujours modifier la configuration par la suite,\n et l'enregistrer ou pas.")
            FlagConf = True
            self.windows.deiconify()
        self.windows.mainloop()

    def maj_image(self):
        vrs = self.version.get()
        fic = resource_path("gif/" + vrs.upper() + ".gif")
        self.fond.delete(self.photo)
        self.photo = PhotoImage(file=fic)
        self.fond.create_image(350,70,image=self.photo,anchor=CENTER)
        self.fond.pack(fill=BOTH, expand=1) 
        
    def set_version_livebox(self):
        self.logged.set_version(self.version.get())
        self.maj_image()

    def set_quoting_livebox(self):
        self.logged.set_quoting(self.quoting.get())

    def set_debugging_livebox(self):
        self.logged.set_debugging(self.debugging.get())
        
        
    def saveinfo(self):
        text = self.text_all.get("1.0",END)
        if len(text) < 2:
            return
        try:
            name = "liveboxinfo_%s.txt" % time.strftime("%d_%m_%Y_%H_%M_%S", time.localtime())
            f = open(name, "w")
            f.write(text)
            f.close()
            messagebox.showinfo('Info', "Les données ont été sauvegardées dans le fichier " + name +".\nSi vous devez ré-utiliser ces données publiquement, sachez qu'aucun filtrage n'a été effectué.\nPour une utilisation publique des données, il vaut mieux passer par l'onglet 'Publication forum'.")
        except Exception as err:
            messagebox.showerror('Error', err)

    def savedbg(self):
        text = self.text_DEBUG.get("1.0",END)
        if len(text) < 2:
            return
        try:
            name = "liveboxinfo_debug_%s.txt" % time.strftime("%d_%m_%Y_%H_%M_%S", time.localtime())
            f = open(name, "w")
            f.write(text)
            f.close()
            messagebox.showinfo('Info', "Les données de debug ont été sauvegardées dans le fichier " + name +".\nSi vous devez ré-utiliser ces données publiquement, vérifiez que tous les filtrages ont été correctement effectués.")
        except Exception as err:
            messagebox.showerror('Error', err)
            
    def copy_clipboard(self):
        cb = Tk()
        text = self.text_FONO.get("1.0",END)
        cb.withdraw()
        cb.clipboard_clear()
        # text to clipboard
        cb.clipboard_append(text)
        messagebox.showinfo('Info', "Les données ont été copiées dans le presse-papiers, ne fermez pas l'outil avant de les avoir copiées ou postées.\nSi vous postez ces données sur le forum, veillez à ne rien modifier, les filtrages nécessaires ont déjà été effectués, tout ce qui est non-filtré peut être utile (voire nécessaire).")
        cb.after(200, cb.destroy())

    def copy_debug_clipboard(self):
        cb = Tk()
        text = self.text_DEBUG.get("1.0",END)
        cb.withdraw()
        cb.clipboard_clear()
        # text to clipboard
        cb.clipboard_append(text)
        messagebox.showinfo('Info', "Les données ont été copiées dans le presse-papiers, ne fermez pas l'outil avant de les avoir copiées ou postées.\nSi vous postez ces données sur le forum, veuillez vérifier que les filtrages nécessaires ont bien été effectués.")
        cb.after(200, cb.destroy())
        
    def savelogin(self):
        self.logged.set_url(self.entry_url.get())
        self.logged.set_user(self.entry_user.get())
        self.logged.set_password(self.entry_password.get())
        if self.logged.save():
            messagebox.showinfo('Info', "Le fichier de configuration a été sauvegardé.")
        else:
            messagebox.showerror('Error', "Le fichier de configuration n'a pas pu être sauvegardé.")

            
    def update(self):
        self.notebook.hide(self.frame_DEBUG)
        lbversion = self.logged.get_version()
        # D'abord, nettoyer les différents onglets
        self.text_DeviceInfo.config(state=NORMAL)
        self.text_DeviceInfo.delete('1.0', END)
        self.text_DeviceInfo.config(state=DISABLED)
        self.text_WanStatus.config(state=NORMAL)
        self.text_WanStatus.delete('1.0', END)
        self.text_WanStatus.config(state=DISABLED)
        self.text_VoipConfig.config(state=NORMAL)
        self.text_VoipConfig.delete('1.0', END)
        self.text_VoipConfig.config(state=DISABLED)
        self.text_WiFi.config(state=NORMAL)
        self.text_WiFi.delete('1.0', END)
        self.text_WiFi.config(state=DISABLED)
        self.text_DSLStats.config(state=NORMAL)
        self.text_DSLStats.delete('1.0', END)
        self.text_DSLStats.config(state=DISABLED)
        self.text_IPTVStatus.config(state=NORMAL)
        self.text_IPTVStatus.delete('1.0', END)
        self.text_IPTVStatus.config(state=DISABLED)
        self.text_all.config(state=NORMAL)
        self.text_all.delete('1.0', END)
        self.text_all.config(state=DISABLED)
        self.text_FONO.config(state=NORMAL)
        self.text_FONO.delete('1.0', END)
        self.text_FONO.config(state=DISABLED)
        self.text_DEBUG.config(state=NORMAL)
        self.text_DEBUG.delete('1.0', END)
        self.text_DEBUG.config(state=DISABLED)
        
        DEBUG = ''
        FlagH = 'non'
        
        def var_filter(VAR):
            tempvar=''
            for packet in VAR.split('\n'):
                packet = re.sub(r"'(([0-9A-F]{2}:){2})([0-9A-F]{2}:){3}[0-9A-F]{2}': \{", r"'\1XX:XX:XX:XX': {", packet)
                psl = len(packet.split(','))
                num = 1
                for line in packet.split(','):
                    if 'SerialNumber' in line:
                        line = re.sub(r"[A-Z0-9]{8}'", r"XXXXXXXX'", line)
                    elif 'ProvisioningCode' in line:
                        line = re.sub(r'[0-9]{4}', r'XXXX', line) + ", "
                    elif 'IPRouters' in line:
                        line = re.sub(r"(\.[0-9]{1,3}){2}'", r".XX.XX'", line)
                    elif 'IPAddress' in line:
                        line = re.sub(r"(\.[0-9]{1,3}){2}'", r".XX.XX'", line)
                    elif 'SegwIPAddress' in line:
                        line = re.sub(r"(\.[0-9]{1,3}){2}'", r".XX.XX'", line)
                    elif 'RemoteGateway' in line:
                        line = re.sub(r"(\.[0-9]{1,3}){2}'", r".XX.XX'", line)
                    elif 'MACAddress' in line:
                        line = re.sub(r"(:[0-9A-Fa-f]{2}){4}'",r":XX:XX:XX:XX'", line)
                    elif 'IPv6Address' in line:
                        line = re.sub(r":([^ '][0-9A-Fa-f]{0,4})", r":XXXX", line)
                    elif 'IPv6DelegatedPrefix' in line:
                        line = re.sub(r"::/[0-9A-Fa-f]+", r"::/XX", line)
                        line = re.sub(r"(:[^/ '][0-9A-Fa-f][^:]{0,4})", r":XXXX", line)
                    elif 'Value' in line:
                        line = re.sub(r"([0-9A-Z]{14}')", r"XXXXXXXXXXXXXX'", line)
                    elif 'DHCPServer' in line:
                        line = re.sub(r"(\.[0-9]{1,3}){2}'", r".XX.XX'", line)
                    elif 'Username' in line:
                        line = re.sub(r": u'fti/([0-9a-zA-Z]+)'", ": u'fti/XXXXXXXX'", line)
                        line = re.sub(r": 'fti/([0-9a-zA-Z]+)'", ": 'fti/XXXXXXXX'", line)
                    elif "'Password'" in line:
                        line = re.sub(r": u'([0-9a-zA-Z]*)'", ": u'XXXXXXXX'", line)
                        line = re.sub(r": '([0-9a-zA-Z]*)'", ": 'XXXXXXXX'", line)
                    elif "'authUserName'" in line:
                        line = re.sub(r": u'([0-9a-zA-Z]*)'", ": u'XXXXXXXX'", line)
                        line = re.sub(r": '([0-9a-zA-Z]*)'", ": 'XXXXXXXX'", line)
                    elif "'authPassword'" in line:
                        line = re.sub(r": u'([0-9a-zA-Z]*)'", ": u'XXXXXXXX'", line)
                        line = re.sub(r": '([0-9a-zA-Z]*)'", ": 'XXXXXXXX'", line)
                    elif "'eventSubscribeAuthUserName'" in line:
                        line = re.sub(r": u'([0-9a-zA-Z]*)'", ": u'XXXXXXXX'", line)
                        line = re.sub(r": '([0-9a-zA-Z]*)'", ": 'XXXXXXXX'", line)
                    elif "'eventSubscribeAuthPassword'" in line:
                        line = re.sub(r": u'([0-9a-zA-Z]*)'", ": u'XXXXXXXX'", line)
                        line = re.sub(r": '([0-9a-zA-Z]*)'", ": 'XXXXXXXX'", line)
                    elif 'ULA' in line:
                        line = re.sub(r"([0-9a-f]{1,4})", replacement, line)
                    elif 'directoryNumber' in line:
                        line = re.sub(r"'(.[0-9]{0,3})[0-9]{0,8}'", r"'\1XXXXXXXX'", line)
                    elif "'SSID'" in line:
                        if not 'orange' in line:
                            line = re.sub(r"([0-9A-Fa-z-]){4}'", r"XXXX'", line)
                        else:
                            line = line
                    elif "'BSSID'" in line:
                        line = re.sub(r"(([0-9a-zA-Z]){2}:){3}([0-9a-zA-Z]){2}[ ]*'", r"XX:XX:XX:XX'", line)
                    elif "'WEPKey'" in line:
                        line = re.sub(r"': u'([^ ]+)'", r"': u'XXXXXXXXXXX'", line)
                        line = re.sub(r"': '([^ ]+)'", r"': 'XXXXXXXXXXX'", line)
                    elif "'PreSharedKey'" in line:
                        line = re.sub(r"': u'([^ ]+)'", r"': u'XXXXXXXX'", line)
                        line = re.sub(r"': '([^ ]+)'", r"': 'XXXXXXXX'", line)
                    elif 'KeyPassPhrase' in line:
                        line = re.sub(r"': u'([^ ]+)'", r"': u'XXXXXXXX'", line)
                        line = re.sub(r"': '([^ ]+)'", r"': 'XXXXXXXX'", line)
                    elif 'SelfPIN' in line:
                        tempvar += line + ","
                        line = re.sub(r"[0-9]{1,8}'",replacement, line) + "'"

                    if num != psl:
                        tempvar += line + ","
                    elif num == psl:
                        tempvar += line
                    num += 1
            VAR = str(tempvar)
            return VAR
        

        # Traiter les versions de LiveBox
        if lbversion == 'auto':
            ver = init_version(self.entry_url.get())
            if ver == 'erreur':
                messagebox.showerror('Erreur', 'LiveBox hors ligne ou non reconnue à cette adresse.')
                ver = 'auto'
                return False
            elif ver == 'inconnu':
                messagebox.showerror('Info', 'Modèle de LiveBox inconnu, on essaie quand-même.')
            self.version.set(ver)
            self.logged.set_version(self.version.get())
            self.maj_image()

        # Traiter les paramètres
        self.logged.set_url(self.entry_url.get())
        self.logged.set_user(self.entry_user.get())
        self.logged.set_password(self.entry_password.get())
        quoting = self.logged.get_quoting()
        debugging = self.logged.get_debugging()
        lb = Livebox(self.logged.get_url(), self.logged.get_version())
        if not lb.login(self.logged.get_user(), self.logged.get_password()):
            return False
       
        # Calculer le temps en secondes depuis EPOCH
        reftime = int(time.mktime(time.localtime()))
        
        # Traitement des infos Device
        DevInfo = lb.device_info()
        
        uptime = int(DevInfo['UpTime'])
        starttime= reftime - int(uptime)
        StartTime = time.ctime(starttime)
        Date_Demarrage = time.strftime("%d/%m/%Y %H:%M:%S", time.localtime(starttime))
        jours = str(int(uptime / 86400))
        heures =  str(int(uptime % 86400 / 3600))
        minutes = str(int(uptime % 86400 % 3600 / 60))
        secondes = str(int(uptime % 86400 % 3600 % 60))
        Start = jours + "j " + heures + "h " + minutes + "mn " + secondes + "s"
        
        #
        Result_Header = "\nRésultats extraits avec " + progname + " version " + Version + " le " + time.strftime("%d/%m/%Y à %H:%M:%S", time.localtime()) + "\n\n"

        if 'NumberOfReboots' not in DevInfo:
            NOR = 'Indisponible avec cette version'
        else:
            NOR = str(DevInfo['NumberOfReboots'])
            
        DeviceInfo =  Result_Header
        # # Début de DeviceInfo
        try:
            DeviceInfo += " Device Info" + "\n"
            DeviceInfo += "    Manufacturer                 :  " + str(DevInfo['Manufacturer']) + "\n"
            DeviceInfo += "    ManufacturerOUI              :  " + str(DevInfo['ManufacturerOUI']) + "\n"
            DeviceInfo += "    ModelName                    :  " + str(DevInfo['ModelName']) + "\n"
            DeviceInfo += "    Description                  :  " + str(DevInfo['Description']) + "\n"
            DeviceInfo += "    ProductClass                 :  " + str(DevInfo['ProductClass']) + "\n"
            DeviceInfo += "    SerialNumber                 :  " + str(DevInfo['SerialNumber']) + "\n"
            DeviceInfo += "    HardwareVersion              :  " + str(DevInfo['HardwareVersion']) + "\n"
            DeviceInfo += "    SAH_Version                  :  " + str(sah) + "\n"
            DeviceInfo += "    SoftwareVersion              :  " + str(DevInfo['SoftwareVersion']) + "\n"
            DeviceInfo += "    RescueVersion                :  " + str(DevInfo['RescueVersion']) + "\n"
            DeviceInfo += "    ModemFirmwareVersion         :  " + str(DevInfo['ModemFirmwareVersion']) + "\n"
            DeviceInfo += "    HardwareVersion 2            :  " + str(DevInfo['AdditionalHardwareVersion']) + "\n"
            DeviceInfo += "    SoftwareVersion 2            :  " + str(DevInfo['AdditionalSoftwareVersion']) + "\n"
            DeviceInfo += "    EnabledOptions               :  " + str(DevInfo['EnabledOptions']) + "\n"
            DeviceInfo += "    SpecVersion                  :  " + str(DevInfo['SpecVersion']) + "\n"
            DeviceInfo += "    ProvisioningCode             :  " + str(DevInfo['ProvisioningCode']) + "\n"
            DeviceInfo += "    Device_UpTime                :  " + str(DevInfo['UpTime']) + "\n"
            DeviceInfo += "      Démarrée depuis le         :  " + Date_Demarrage + "\n"
            DeviceInfo += "      Démarrée depuis            :  " + Start + "\n"
            DeviceInfo += "    FirstUseDate                 :  " + str(DevInfo['FirstUseDate']) + "\n"
            DeviceInfo += "    ManufacturerURL              :  " + str(DevInfo['ManufacturerURL']) + "\n"
            DeviceInfo += "    Country                      :  " + str(DevInfo['Country']) + "\n"
            DeviceInfo += "    ExternalIPAddress            :  " + str(DevInfo['ExternalIPAddress']) + "\n"
            DeviceInfo += "    DeviceStatus                 :  " + str(DevInfo['DeviceStatus']) + "\n"
            DeviceInfo += "    NumberOfReboots              :  " + NOR + "\n"
            #
            self.text_DeviceInfo.config(state=NORMAL)
            self.text_DeviceInfo.delete('1.0', END)
            self.text_DeviceInfo.insert(INSERT, DeviceInfo)
            self.text_DeviceInfo.config(state=DISABLED)
        except BaseException as err:
            DEBUG += "  Erreurs relevées sur DeviceInfo. Contenu de DevInfo :\n"
            DEBUG += "    " + var_filter(str(DevInfo)) + "\n"
            DEBUG += " Message d'erreur : " + str(err) + "\n"
        # # Fin de DeviceInfo

        # # Début de WanStatus
        mtu = str(lb.mtu())
        vlanid = str(lb.vlan_id())
        try:
            wanstatus = lb.wan_status()
            
            # On aura besoin plus loin de tester le type de lien
            LinkType = wanstatus['LinkType']
            
            # Adresse IP et Gateway peuvent ne pas être renseignés (connexion non établie)
            if 'IPAddress' not in str(wanstatus):
                IpAdr = 'Non disponible'
            else:
                IpAdr = wanstatus['IPAddress']
            
            if 'RemoteGateway' not in str(wanstatus):
                RmGw = 'Non disponible'
            else:
                RmGw = wanstatus['RemoteGateway']
            dns = wanstatus['DNSServers'].split(',')
            
            WanStatus  = " WAN Status" + "\n"
            WanStatus += "    LinkType                     :  " + wanstatus['LinkType'] + "\n"
            WanStatus += "    LinkState                    :  " + wanstatus['LinkState'] + "\n"
            WanStatus += "    MACAddress                   :  " + wanstatus['MACAddress'] + "\n"
            WanStatus += "    Protocol                     :  " + wanstatus['Protocol'] + "\n"
            WanStatus += "    ConnectionState              :  " + wanstatus['ConnectionState'] + "\n"
            WanStatus += "    LastConnectionError          :  " + wanstatus['LastConnectionError'] + "\n"
            WanStatus += "    IPAddress                    :  " + IpAdr + "\n"
            WanStatus += "    RemoteGateway                :  " + RmGw + "\n"
            WanStatus += "    DNSServers\n"
            for server in range(len(dns)):
                WanStatus += "      DNS " + str(server + 1) + "                      :  " + dns[server] + "\n"
            WanStatus += "    IPv6Address                  :  " + wanstatus['IPv6Address'] + "\n"
            if 'IPv6DelegatedPrefix' in wanstatus:
                WanStatus += "    IPv6DelegatedPrefix          :  " + wanstatus['IPv6DelegatedPrefix'] + "\n"
            WanStatus += "    VLAN ID                      :  " + vlanid + "\n"
            WanStatus += "    MTU                          :  " + mtu + "\n"
            
            if wanstatus['Protocol'] == "dhcp":
                DHCPMibs = lb.dhcp_mibs()
                DHCPUpTime = DHCPMibs["dhcp"]["dhcp_data"]["Uptime"]
                jours = str(int(DHCPUpTime / 86400))
                heures =  str(int(DHCPUpTime % 86400 / 3600))
                minutes = str(int(DHCPUpTime % 86400 % 3600 / 60))
                secondes = str(int(DHCPUpTime % 86400 % 3600 % 60))
                WanUpTime  = jours + "j " + heures + "h " + minutes + "mn " + secondes + "s"
                
                WanStatus += "\n WAN DHCP infos" + "\n"
                WanStatus += "    SubnetMask                   :  " + str(DHCPMibs["dhcp"]["dhcp_data"]['SubnetMask']) + "\n"
                WanStatus += "    DHCPServer                   :  " + str(DHCPMibs["dhcp"]["dhcp_data"]['DHCPServer']) + "\n"
                WanStatus += "    LeaseTime                    :  " + str(DHCPMibs["dhcp"]["dhcp_data"]['LeaseTime']) + "\n"
                WanStatus += "    LeaseTimeRemaining           :  " + str(DHCPMibs["dhcp"]["dhcp_data"]['LeaseTimeRemaining']) + "\n"
                WanStatus += "    DHCP_Uptime                  :  " + str(DHCPMibs["dhcp"]["dhcp_data"]['Uptime']) + "\n"
                WanStatus += "     WAN_Uptime (jhms)           :  " + str(WanUpTime) + "\n"
                WanStatus += "    DSCPMark                     :  " + str(DHCPMibs["dhcp"]["dhcp_data"]['DSCPMark']) + "\n"
                WanStatus += "    PriorityMark                 :  " + str(DHCPMibs["dhcp"]["dhcp_data"]['PriorityMark']) + "\n"
                WanStatus += "    CheckAuthentication          :  " + str(DHCPMibs["dhcp"]["dhcp_data"]['CheckAuthentication']) + "\n"
                WanStatus += "    AuthenticationInformation    :  " + str(DHCPMibs["dhcp"]["dhcp_data"]['AuthenticationInformation']) + "\n"
                WanStatus += "    ResetOnPhysDownTimeout       :  " + str(DHCPMibs["dhcp"]["dhcp_data"]['ResetOnPhysDownTimeout']) + "\n"
                WanStatus += "    RetransmissionStrategy       :  " + str(DHCPMibs["dhcp"]["dhcp_data"]['RetransmissionStrategy']) + "\n"
                WanStatus += "    RetransmissionRenewTimeout   :  " + str(DHCPMibs["dhcp"]["dhcp_data"]['RetransmissionRenewTimeout']) + "\n"
                sent=()
                req=()
                sent += tuple(str(i) for i in DHCPMibs["dhcp"]['dhcp_data']['SentOption'].keys())
                req += tuple(str(i) for i in DHCPMibs["dhcp"]['dhcp_data']['ReqOption'].keys())
                
                sent = list(sorted(sent, key=int))
                req = list(sorted(req, key=int))

                sent = ','.join([str(i) for i in sent])
                req = ','.join([str(i) for i in req])
                
                WanStatus += "    SentOption                   :  " + str(sent) + "\n"
                WanStatus += "    ReqOption                    :  " + str(req) + "\n"
        except BaseException as err:
            DEBUG += "[---]\n"
            DEBUG += "  Erreurs relevées sur WanStatus. Contenu de wanstatus :\n"
            DEBUG += "    " + var_filter(str(wanstatus)) + "\n"
            DEBUG += " Message d'erreur : " + str(err) + "\n"
        
        try:
            wanaccount = lb.account()
        except BaseException as err:
            DEBUG += "[---]\n"
            DEBUG += "  Erreurs relevées sur la récupération de WanAccount. Contenu de wanaccount :\n"
            DEBUG += "    " + var_filter(str(wanaccount)) + "\n"
            DEBUG += " Message d'erreur : " + str(err) + "\n"
        
        WanStatus += "\n Infos du compte WAN\n"
        try:
            if 'Username' in wanaccount:
                WanStatus += "    Nom                          :  " + str(wanaccount['Username']) + "\n"
            else:
                WanStatus += "    Nom                          :  Non trouvé\n"
            if 'Password' in wanaccount:
                WanStatus += "    Password                     :  " + str(wanaccount['Password']) + "\n"
            else:
                WanStatus += "    Password                     :  Non trouvé\n"
            if 'SegwIPAddress' in wanaccount:
                WanStatus += "    SegwIPAddress                :  " + str(wanaccount['SegwIPAddress']) +"\n"
            if 'ULA' in wanaccount:
                WanStatus += "    ULA                          :  " + str(wanaccount['ULA']) + "\n"
        except Exception as err:
            wanaccount = str(wanaccount)
            wanaccount = re.sub(r'fti/[a-zA-Z0-9]+', r'fti/XXXXXXX', wanaccount)
            # wanaccount = re.sub(r"assword': '[0-9a-zA-Z]+'","assword': 'XXXXXXX'", wanaccount)
            wanaccount = re.sub(r"assword': u'[0-9a-zA-Z]+'","assword': u'XXXXXXX'", wanaccount)
            DEBUG += '\nInformations de compte Internet non détectées, données reçues :\n' + var_filter(wanaccount)
            
            WanStatus += "    Problème ... \n"
            WanStatus += "    Merci de fournir les informations de l'onglet 'Debug' à l'auteur, de préférence par Message Privé.\n"
            WanStatus += "    Les filtrages utiles ont, en principe, été effectués (mais on ne sait jamais ...).\n"
            WanStatus += "    Si vous effectuez d'autre(s) filtrage(s), veuillez le signaler ...\n"
        
        self.text_WanStatus.config(state=NORMAL)
        self.text_WanStatus.delete('1.0', END)
        self.text_WanStatus.insert(INSERT, Result_Header + WanStatus)
        
        self.text_WanStatus.config(state=DISABLED)
        # # Fin de WanStatus


        # # Début de VoipConfig
        try:
            res_voip_config = lb.voip_config()
            trunks_list = lb.list_trunks()
            trunks_result = trunks_list['status']
            szTrunks = len(trunks_result)
            
            VOIPConfig  = " Téléphonie IP" + "\n"
            VOIPConfig += '  Non disponible\n'
            TrunkConfig = '\n Etat des protocoles VoIP\n'
            lbversion = self.logged.get_version()
            if lbversion != 'lb3' and lbversion != 'lb4':
                if res_voip_config['status'] == None:
                    voip_config = res_voip_config['data']
                    VOIPConfig  = " Téléphonie IP" + "\n"
                    VOIPConfig += "    Protocol                     :  " + str(voip_config['Protocol']) + "\n"
                    VOIPConfig += "    VPVC                         :  " + str(voip_config['VPVC']) + "\n"
            else:
                voip_config = res_voip_config['status']
                if len(voip_config)>0:
                    VOIPConfig  = " Téléphonie IP" + "\n"
                    VOIPConfig += "  Name                           :  " + str(voip_config[0]['Name']) + "\n"
                    VOIPConfig += "    Enable                       :  " + str(voip_config[0]['Enable']) + "\n"
                    VOIPConfig += "    Protocol                     :  " + str(voip_config[0]['Protocol']) + "\n"
                    VOIPConfig += "    Encapsulation                :  " + str(voip_config[0]['Encapsulation']) + "\n"
                    VOIPConfig += "    InterfaceId                  :  " + str(voip_config[0]['InterfaceId']) + "\n"
                    VOIPConfig += "    Interface                    :  " + str(voip_config[0]['Interface']) + "\n"
                    VOIPConfig += "    PhysInterface                :  " + str(voip_config[0]['PhysInterface']) + "\n"
                    
                    if len(voip_config)>1:
                        VOIPConfig += "  Name                           :  " + str(voip_config[1]['Name']) + "\n"
                        VOIPConfig += "    Enable                       :  " + str(voip_config[1]['Enable']) + "\n"
                        VOIPConfig += "    Protocol                     :  " + str(voip_config[1]['Protocol']) + "\n"
                        VOIPConfig += "    Encapsulation                :  " + str(voip_config[1]['Encapsulation']) + "\n"
                        VOIPConfig += "    InterfaceId                  :  " + str(voip_config[1]['InterfaceId']) + "\n"
                        VOIPConfig += "    Interface                    :  " + str(voip_config[1]['Interface']) + "\n"
                        VOIPConfig += "    PhysInterface                :  " + str(voip_config[1]['PhysInterface']) + "\n"
                    
            if szTrunks>0:
                TrunkConfig += "    Etat SIP                     :  " + str(trunks_result[0]['trunk_lines'][0]['status']) + "\n"
                TrunkConfig += "    Activation SIP               :  " + str(trunks_result[0]['trunk_lines'][0]['enable']) + "\n"
                TrunkConfig += "    Numéro d'annuaire SIP        :  " + str(trunks_result[0]['trunk_lines'][0]['directoryNumber']) + "\n"
                if szTrunks > 1:
                    szTrunk2 = len(trunks_result[1]['trunk_lines'])
                    if szTrunk2 >0:
                        TrunkConfig += "    Etat H323                    :  " + str(trunks_result[1]['trunk_lines'][0]['status']) + "\n"
                        TrunkConfig += "    Activation H323              :  " + str(trunks_result[1]['trunk_lines'][0]['enable']) + "\n"
                        TrunkConfig += "    Numéro d'annuaire H323       :  " + str(trunks_result[1]['trunk_lines'][0]['directoryNumber']) + "\n"
            
            VOIPConfig += TrunkConfig
        except BaseException as err:
            DEBUG += "[---]\n"
            DEBUG += "  Erreurs relevées sur VOIPConfig. Contenu de res_voip_config :\n"
            DEBUG += "    " + var_filter(str(res_voip_config)) + "\n"
            DEBUG += "  Erreurs relevées sur VOIPConfig. Contenu de trunks_list :\n"
            DEBUG += "    " + var_filter(str(trunks_list)) + "\n"
            DEBUG += "  Erreurs relevées sur VOIPConfig. Contenu de VOIPConfig :\n"
            for line in VOIPConfig.split('\n'):
                DEBUG += "    " + var_filter(line) + "\n"
            # DEBUG += "    " + var_filter(VOIPConfig) + "\n"
            DEBUG += " Message d'erreur : " + str(err) + "\n"
        
        self.text_VoipConfig.config(state=NORMAL)
        self.text_VoipConfig.delete('1.0', END)
        self.text_VoipConfig.insert(INSERT, Result_Header + VOIPConfig)
        self.text_VoipConfig.config(state=DISABLED)
        # # Fin de VoipConfig

        # # Début de Wi-Fi
        try:
            WifiData = lb.wifi_mibs()
            WifiAth0 = ''
            WifiAth1 = ''
            WifiWL0  = ''
            WifiWL1  = ''
            
            if 'wifi0_ath' in WifiData['wlanradio']:
                WifiAth0 = 'wifi0_ath'
            
            if 'wifi0_bcm' in WifiData['wlanradio']:
                WifiAth0 = 'wifi0_bcm'

            if 'wifi1_ath' in WifiData['wlanradio']:
                WifiAth1 = 'wifi1_ath'
            
            if 'wifi0_quan' in WifiData['wlanradio']:
                WifiAth1 = 'wifi0_quan'
                
            if 'wl0' in WifiData['wlanvap']:
                WifiWL0 = 'wl0'
            
            if 'eth5' in WifiData['wlanvap']:
                WifiWL0 = 'eth5'  #FIXME es-ce bien WifiWL0 et pas WifiWL1 ?

            if 'wl1' in WifiData['wlanvap']:
                WifiWL1 = 'wl1'
            
            if 'eth4' in WifiData['wlanvap']: #livebox 5
                WifiWL1 = 'eth4' 
            
            if 'eth6' in WifiData['wlanvap']:
                WifiWL1 = 'eth6'
            
            szWifData = len(WifiData['wlanradio'])
            WifiConf  = " Etat Wi-Fi" + "\n"
            WifiConf += "\nInterface: " + WifiAth0 + "\n"
            WifiConf += "  Fréquence                      :  " + str(WifiData['wlanradio'][WifiAth0]['OperatingFrequencyBand']) + "\n"
            WifiConf += "    SupportedBands               :  " + str(WifiData['wlanradio'][WifiAth0]['SupportedFrequencyBands']) + "\n"
            WifiConf += "    OperatingStandards           :  " + str(WifiData['wlanradio'][WifiAth0]['OperatingStandards']) + "\n"
            WifiConf += "    Channel                      :  " + str(WifiData['wlanradio'][WifiAth0]['Channel']) + "\n"
            WifiConf += "    AutoChannelEnable            :  " + str(WifiData['wlanradio'][WifiAth0]['AutoChannelEnable']) + "\n"
            WifiConf += "    SSID                         :  " + str(WifiData['wlanvap'][WifiWL0]['SSID']) + "\n"
            WifiConf += "    SSID visible                 :  " + str(WifiData['wlanvap'][WifiWL0]['SSIDAdvertisementEnabled']) + "\n"
            WifiConf += "    BSSID                        :  " + str(WifiData['wlanvap'][WifiWL0]['BSSID']) + "\n"
            WifiConf += "    WEPKey                       :  " + str(WifiData['wlanvap'][WifiWL0]['Security']['WEPKey']) + "\n"
            WifiConf += "    PreSharedKey                 :  " + str(WifiData['wlanvap'][WifiWL0]['Security']['PreSharedKey']) + "\n"
            WifiConf += "    KeyPassPhrase                :  " + str(WifiData['wlanvap'][WifiWL0]['Security']['KeyPassPhrase']) + "\n"
            WifiConf += "    ModeEnabled                  :  " + str(WifiData['wlanvap'][WifiWL0]['Security']['ModeEnabled']) + "\n"
            WifiConf += "    MACFiltering                 :  " + str(WifiData['wlanvap'][WifiWL0]['MACFiltering']['Mode']) + "\n"
            WifiConf += "    WPSEnable                    :  " + str(WifiData['wlanvap'][WifiWL0]['WPS']['Enable']) + "\n"
            WifiConf += "    WPSSelfPIN                   :  " + str(WifiData['wlanvap'][WifiWL0]['WPS']['SelfPIN']) + "\n"
            WifiConf += "    WPSConfigMethodsEnabled      :  " + str(WifiData['wlanvap'][WifiWL0]['WPS']['ConfigMethodsEnabled']) + "\n"

            if szWifData > 1:
                WifiConf += "\nInterface: " + WifiAth1 + "\n"
                WifiConf += "  Fréquence                      :  " + str(WifiData['wlanradio'][WifiAth1]['OperatingFrequencyBand']) + "\n"
                WifiConf += "    SupportedBands               :  " + str(WifiData['wlanradio'][WifiAth1]['SupportedFrequencyBands']) + "\n"
                WifiConf += "    OperatingStandards           :  " + str(WifiData['wlanradio'][WifiAth1]['OperatingStandards']) + "\n"
                WifiConf += "    Channel                      :  " + str(WifiData['wlanradio'][WifiAth1]['Channel']) + "\n"
                WifiConf += "    AutoChannelEnable            :  " + str(WifiData['wlanradio'][WifiAth1]['AutoChannelEnable']) + "\n"
                if WifiWL1 != "" and WifiWL1 in WifiData['wlanvap']:
                    WifiConf += "    SSID                         :  " + str(WifiData['wlanvap'][WifiWL1]['SSID']) + "\n"
                    WifiConf += "    SSID visible                 :  " + str(WifiData['wlanvap'][WifiWL1]['SSIDAdvertisementEnabled']) + "\n"
                    WifiConf += "    BSSID                        :  " + str(WifiData['wlanvap'][WifiWL1]['BSSID']) + "\n"
                    WifiConf += "    WEPKey                       :  " + str(WifiData['wlanvap'][WifiWL1]['Security']['WEPKey']) + "\n"
                    WifiConf += "    PreSharedKey                 :  " + str(WifiData['wlanvap'][WifiWL1]['Security']['PreSharedKey']) + "\n"
                    WifiConf += "    KeyPassPhrase                :  " + str(WifiData['wlanvap'][WifiWL1]['Security']['KeyPassPhrase']) + "\n"
                    WifiConf += "    ModeEnabled                  :  " + str(WifiData['wlanvap'][WifiWL1]['Security']['ModeEnabled']) + "\n"
                    WifiConf += "    MACFiltering                 :  " + str(WifiData['wlanvap'][WifiWL1]['MACFiltering']['Mode']) + "\n"
                    WifiConf += "    WPSEnable                    :  " + str(WifiData['wlanvap'][WifiWL1]['WPS']['Enable']) + "\n"
                    WifiConf += "    WPSSelfPIN                   :  " + str(WifiData['wlanvap'][WifiWL1]['WPS']['SelfPIN']) + "\n"
                    WifiConf += "    WPSConfigMethodsEnabled      :  " + str(WifiData['wlanvap'][WifiWL1]['WPS']['ConfigMethodsEnabled']) + "\n"
                
            
            WifiCom = lb.wifi_com_status()
            WifiComm  = " Wi-Fi partagé" + "\n"
            if 'result' in WifiCom: # n'existe plus sur lb5? devenu mode invité?
                WifiComm += "    SSID                         :  " + str(WifiCom['result']['data']['SSID']) + "\n"
                WifiComm += "    Status                       :  " + str(WifiCom['result']['data']['Status']) + "\n"
                WifiComm += "    Enable                       :  " + str(WifiCom['result']['data']['Enable']) + "\n"
        
        except BaseException as err:
            DEBUG += "[---]\n"
            DEBUG += "  Erreurs relevées sur WiFi. Contenu de wifi_mibs :\n"
            DEBUG += "    " + var_filter(str(WifiData)) + "\n"
            DEBUG += "  Erreurs relevées sur WiFi. Contenu de WifiConf :\n"
            DEBUG += "    " + var_filter(str(WifiConf)) + "\n"
            DEBUG += "  Erreurs relevées sur WiFi. Contenu de WifiCom :\n"
            DEBUG += "    " + var_filter(str(WifiCom)) + "\n"
            DEBUG += " Message d'erreur : " + str(err) + "\n"
        
        self.text_WiFi.config(state=NORMAL)
        self.text_WiFi.delete('1.0', END)
        self.text_WiFi.insert(INSERT, Result_Header + WifiConf + "\n" + WifiComm)
        self.text_WiFi.config(state=DISABLED)
        # # Fin de Wi-Fi

        # # Début de getDSLStats
        DSLStats = ""
        dslstats = ""
        DslMibs = ""
        try:
            if LinkType == "ethernet":
                dslstats = lb.DSLStats()
         
                DslMibs = lb.dsl_mibs()
                LastChange = DslMibs["dsl"]["dsl0"]["LastChange"]
                jours = str(int(LastChange / 86400))
                heures =  str(int(LastChange % 86400 / 3600))
                minutes = str(int(LastChange % 86400 % 3600 / 60))
                secondes = str(int(LastChange % 86400 % 3600 % 60))
                LastChangeTime  = jours + " j " + heures + " h " + minutes + " m " + secondes + " s"

                DSLStats += "  /!\ Les résultats suivants (DSL) ne sont pas significatifs avec un WAN Ethernet" + "\n"

                DSLStats += " Etat de la ligne DSL\n"
                DSLStats += "    Statut du lien               :  " + str(DslMibs["dsl"]["dsl0"]["LinkStatus"]) + "\n"
                DSLStats += "    LastChangeTime               :  " + str(DslMibs["dsl"]["dsl0"]["LastChangeTime"]) + "\n"
                DSLStats += "    LastChange                   :  " + str(DslMibs["dsl"]["dsl0"]["LastChange"]) + "\n"
                DSLStats += "    Durée de la synchronisation  :  " + str(LastChangeTime) + "\n"
                DSLStats += "    Mode de synchronisation      :  " + str(DslMibs["dsl"]["dsl0"]["ModulationType"]) + "\n"
                DSLStats += "    ModulationHint               :  " + str(DslMibs["dsl"]["dsl0"]["ModulationHint"]) + "\n"
                DSLStats += "    DataPath                     :  " + str(DslMibs["dsl"]["dsl0"]["DataPath"]) + "\n"
                DSLStats += "    InterleaveDepth              :  " + str(DslMibs["dsl"]["dsl0"]["InterleaveDepth"]) + "\n"
                DSLStats += "    Profil DSL                   :  " + str(DslMibs["dsl"]["dsl0"]["CurrentProfile"]) + "\n"
                DSLStats += "    UPBOKLE                      :  " + str(DslMibs["dsl"]["dsl0"]['UPBOKLE']) + "\n"
                DSLStats += "    Standard utilisé             :  " + str(DslMibs["dsl"]["dsl0"]["StandardUsed"]) + "\n"
                DSLStats += "    Firmware Version             :  " + str(DslMibs["dsl"]["dsl0"]["FirmwareVersion"]) + "\n"
                DSLStats += "\n Débit et marge au bruit\n"
                DSLStats += "  Descendant\n"
                DSLStats += "    Atténuation                  :  " + str(DslMibs["dsl"]["dsl0"]["DownstreamAttenuation"]/10.0) + " dB\n"
                DSLStats += "    Débit de synchronisation     :  " + str(DslMibs["dsl"]["dsl0"]["DownstreamCurrRate"]) + " Kb/s\n"
                DSLStats += "    Débit max de synchronisation :  " + str(DslMibs["dsl"]["dsl0"]["DownstreamMaxRate"]) + " Kb/s\n"
                DSLStats += "    Marge de bruit               :  " + str(DslMibs["dsl"]["dsl0"]["DownstreamNoiseMargin"]/10.0) + " dB\n"
                DSLStats += "    Puissance                    :  " + str(DslMibs["dsl"]["dsl0"]["DownstreamPower"]) + "\n"
                DSLStats += "  Montant\n"
                DSLStats += "    Atténuation                  :  " + str(DslMibs["dsl"]["dsl0"]["UpstreamAttenuation"]/10.0) + " dB\n"
                DSLStats += "    Débit de synchronisation     :  " + str(DslMibs["dsl"]["dsl0"]["UpstreamCurrRate"]) + " Kb/s\n"
                DSLStats += "    Débit max de synchronisation :  " + str(DslMibs["dsl"]["dsl0"]["UpstreamMaxRate"]) + " Kb/s\n"
                DSLStats += "    Marge de bruit               :  " + str(DslMibs["dsl"]["dsl0"]["UpstreamNoiseMargin"]/10.0) + " dB\n"
                DSLStats += "    Puissance                    :  " + str(DslMibs["dsl"]["dsl0"]["UpstreamPower"]) + "\n"
            
                
                DSLStats += "\n Statistiques de la ligne" + "\n" 
                DSLStats += "    ReceiveBlocks                :  " + str(dslstats['ReceiveBlocks']) + "\n"
                DSLStats += "    TransmitBlocks               :  " + str(dslstats['TransmitBlocks']) + "\n"
                DSLStats += "    CellDelin                    :  " + str(dslstats['CellDelin']) + "\n"
                DSLStats += "    LinkRetrain                  :  " + str(dslstats['LinkRetrain']) + "\n"
                DSLStats += "    InitErrors                   :  " + str(dslstats['InitErrors']) + "\n"
                DSLStats += "    InitTimeouts                 :  " + str((dslstats['InitTimeouts'] ^0x80000000) - 0x80000000) + "\n"
                DSLStats += "    LossOfFraming                :  " + str(dslstats['LossOfFraming']) + "\n"
                DSLStats += "    ErroredSecs                  :  " + str(dslstats['ErroredSecs']) + "\n"
                DSLStats += "    SeverelyErroredSecs          :  " + str(dslstats['SeverelyErroredSecs']) + "\n"
                DSLStats += "    FECErrors                    :  " + str(dslstats['FECErrors']) + "\n"
                DSLStats += "    ATUCFECErrors                :  " + str(dslstats['ATUCFECErrors']) + "\n"
                DSLStats += "    HECErrors                    :  " + str(dslstats['HECErrors']) + "\n"
                DSLStats += "    ATUCHECErrors                :  " + str(dslstats['ATUCHECErrors']) + "\n"
                DSLStats += "    CRCErrors                    :  " + str(dslstats['CRCErrors']) + "\n"
                DSLStats += "    ATUCCRCErrors                :  " + str(dslstats['ATUCCRCErrors']) + "\n"
            elif LinkType == "gpon":
                DSLStats += "  /!\ Aucune donnée sur un WAN fibre" + "\n"
                dslstats = "Rien -> lien fibre gpon"
                DslMibs = "Rien -> lien fibre gpon"
        except BaseException as err:
            DEBUG += "[---]\n"
            DEBUG += "  Erreurs relevées sur DSLStats. Contenu de dslstats :\n"
            DEBUG += "    " + var_filter(str(dslstats)) + "\n"
            DEBUG += "  Erreurs relevées sur DSLStats. Contenu de DslMibs :\n"
            DEBUG += "    " + var_filter(str(DslMibs)) + "\n"
            DEBUG += " Message d'erreur : " + str(err) + "\n"

        self.text_DSLStats.config(state=NORMAL)
        self.text_DSLStats.delete('1.0', END)
        self.text_DSLStats.insert(INSERT, Result_Header + DSLStats)
        self.text_DSLStats.config(state=DISABLED)
        # # Fin de getDSLStats

        # # Début de IPTVStatus
        iptvstatus = lb.ip_tv_status()['result']
        IPTV_Status  = " Etat des services TV" + "\n"
        IPTV_Status += "    IPTVStatus                   :  " + iptvstatus['data']['IPTVStatus'] + "\n"
        
        self.text_IPTVStatus.config(state=NORMAL)
        self.text_IPTVStatus.delete('1.0', END)
        self.text_IPTVStatus.insert(INSERT, Result_Header + IPTV_Status)
        self.text_IPTVStatus.config(state=DISABLED)
        # # Fin de IPTVStatus
        
        # # Début de OrangeServices
        # Ne fonctionne pas sur LB3 et antérieures en janvier 2017
        # print((lb.orange_services()))
        # # Fin de OrangeServices
        
        # # Début de ConnectedDevices
        # Pas implémenté
        # print((lb.ws_get_devices(lb.ws_channel_id())))
        # # Fin de ConnectedDevices
        
        self.text_all.config(state=NORMAL)
        self.text_all.delete('1.0', END)
        self.text_all.insert(INSERT, DeviceInfo)
        self.text_all.insert(INSERT, "\n" + WanStatus)
        self.text_all.insert(INSERT, "\n" + VOIPConfig)
        self.text_all.insert(INSERT, "\n" + WifiConf + "\n" + WifiComm)
        self.text_all.insert(INSERT, "\n" + DSLStats)
        self.text_all.insert(INSERT, "\n" + IPTV_Status)
        self.text_all.config(state=DISABLED)
        
        def replacement(obj):
            # L'intérêt de cette fonction est de ne modifier que le nombre d'occurences d'une recherche
            # Elle peut avoir l'inconvénient de masquer également les caractères séparateurs
            return 'X' * len(obj.group(0))
            # # La méthode ci-dessous présente l'intérêt de modifier un sous-ensemble de la substitution appelante
            # # Elle permet de ne pas masquer les éventuels caractères séparateurs
            # # Si d'autres caractères que alpha-numériques sont présentés, ils ne seront pas modifiés
            # return re.sub(r'[0-9a-zA-Z]', 'X', obj.group(0))

        DeviceInfoFONO = ''
        for line in DeviceInfo.split('\n'):
            if 'SerialNumber' in line:
                DeviceInfoFONO += re.sub(r'[A-Z0-9]{8}$', r'XXXXXXXX', line) + "\n"
            elif 'ProvisioningCode' in line:
                DeviceInfoFONO += re.sub(r'[0-9]{4}',r'XXXX', line) + "\n"
            elif  'IPAddress' in line:
                DeviceInfoFONO += re.sub(r'(\.[0-9]{1,3}){2}$', r'.XX.XX', line) + "\n"
            else:
                DeviceInfoFONO += line + "\n"
        
        WanStatusFONO = ''
        for line in WanStatus.split('\n'):
            if 'IPAddress' in line:
                WanStatusFONO += re.sub(r'(\.[0-9]{1,3}){2}$', r'.XX.XX', line) + "\n"
            elif 'RemoteGateway' in line:
                WanStatusFONO += re.sub(r'(\.[0-9]{1,3}){2}$', r'.XX.XX', line) + "\n"
            elif 'MACAddress' in line:
                WanStatusFONO += re.sub(r'(:[0-9A-Fa-f]{2}){4}$',r':XX:XX:XX:XX', line) + "\n"
            elif 'IPv6Address' in line:
                # La chaîne de substitution pourrait varier, IPV6 le permettant.
                # De plus, cette méthode combine une meilleure anonymisation et une écriture plus synthétique.
                WanStatusFONO += re.sub(r'([0-9A-Fa-f]{0,4}:){6}[0-9A-Fa-f]{1,4}$', replacement, line) + "\n"
            elif 'IPv6DelegatedPrefix' in line:
                line = re.sub(r"::/[0-9A-Fa-f]+", r"::/XX", line)
                WanStatusFONO += re.sub(r"(:[^/][0-9A-Fa-f][^:]{0,4})", r":XXXX", line) + "\n"
            elif 'DHCPServer' in line:
                WanStatusFONO += re.sub(r'(\.[0-9]{1,3}){2}$', r'.XX.XX', line) + "\n"
            elif 'Nom' in line:
                WanStatusFONO += re.sub(r'([0-9a-zA-Z]+)$', replacement, line) + "\n"
            elif 'Password' in line:
                WanStatusFONO += re.sub(r'([0-9a-zA-Z]+)$', replacement, line) + "\n"
            elif 'SegwIPAddress' in line:
                WanStatusFONO += re.sub(r'(\.[0-9]{1,3}){2}$', r'.XX.XX', line) + "\n"
            elif 'ULA' in line:
                WanStatusFONO += re.sub(r"([0-9a-f]{1,4})", replacement, line) + "\n"
            else:
                WanStatusFONO += line + "\n"
        
        VOIPConfigFONO = ''
        for line in VOIPConfig.split('\n'):
            if 'annuaire' in line:
                VOIPConfigFONO += re.sub(r'[0-9]{8}$', replacement, line) + "\n"
            else:
                VOIPConfigFONO += line + "\n"
        
        WifiConfFONO = ''
        for line in WifiConf.split('\n'):
            if ' SSID  ' in line:
                WifiConfFONO += re.sub(r'.{4}$', r'XXXX', line) + "\n"
            elif ' BSSID ' in line:
            # Attention ici, le BSSID peut finir par des espaces sur LB2 :|
                WifiConfFONO += re.sub(r'(.{2}:){3}.{2} *$', r'XX:XX:XX:XX', line) + "\n"
            elif 'WEPKey' in line:
                # Les clés peuvent avoir été personnalisées, ou leur longueur peut changer, selon les versions de LB
                # En procédant comme ci-dessous, on change tous les caractères alpha-numériques de la clé
                # On aurait aussi pu repartir de la longueur de valeur trouvée en créant WifiConf
                WifiConfFONO += re.sub(r'[^ ]+$', replacement, line) + "\n"
            elif 'PreSharedKey' in line:
                WifiConfFONO += re.sub(r'[^ ]+$', replacement, line) + "\n"
            elif 'KeyPassPhrase' in line:
                WifiConfFONO += re.sub(r'[^ ]+$', replacement, line) + "\n"
            elif 'SelfPIN' in line:
                # Un code PIN d'appairement contient en principe 8 caractères numériques.
                # S'il en contient plus, les premiers en surplus ne seront pas masqués.
                WifiConfFONO += re.sub(r'[0-9]{1,8}$',replacement, line) + "\n"
            else:
                WifiConfFONO += line + "\n"  
        
        self.text_FONO.config(state=NORMAL)
        self.text_FONO.delete('1.0', END)
        self.text_FONO.insert(INSERT, "[" + quoting + "]\n" + DeviceInfoFONO)
        self.text_FONO.insert(INSERT, "[---]\n\n" + WanStatusFONO)
        self.text_FONO.insert(INSERT, "[---]\n\n" + VOIPConfigFONO)
        self.text_FONO.insert(INSERT, "[---]\n\n" + WifiConfFONO + WifiComm + "\n")
        self.text_FONO.insert(INSERT, "[---]\n\n" + DSLStats + "\n")
        self.text_FONO.insert(INSERT, "[---]\n\n" + IPTV_Status + "\n" + "[/" + quoting + "]")
        self.text_FONO.config(state=DISABLED)
        
        if len(DEBUG) > 0:
            DEBUG = Result_Header + DEBUG + '\n[---]\n'
            FlagH = 'oui'
            self.notebook.add(self.frame_DEBUG)
            self.text_DEBUG.config(state=NORMAL)
            self.text_DEBUG.delete('1.0', END)
            self.text_DEBUG.insert(INSERT, "[" + quoting + "]\n\n" + DEBUG)
            self.text_DEBUG.insert(INSERT, "\n\n" + "[/" + quoting + "]")
            self.text_DEBUG.config(state=DISABLED)
        
        if debugging == 'oui':
            DEBUG += "  Contenu de DevInfo :\n"
            DEBUG += var_filter(str(DevInfo)) + "\n\n"
            DEBUG += "  Contenu de mtu :\n"
            DEBUG += str(mtu) + "\n\n"
            DEBUG += "  Contenu de vlanid :\n"
            DEBUG += str(vlanid) + "\n\n"
            DEBUG += '[---]' + '\n'
            DEBUG += "  Contenu de wanstatus :\n"
            DEBUG += var_filter(str(wanstatus)) + "\n\n"
            if wanstatus['Protocol'] == "dhcp":
                DEBUG += "  Contenu de DHCPMibs :\n"
                DEBUG += var_filter(str(DHCPMibs)) + "\n\n"
            if len(wanaccount) >0:
                DEBUG += '[---]' + '\n'
                DEBUG += "  Contenu de wanaccount :\n"
                DEBUG += var_filter(str(wanaccount)) + "\n\n"
            DEBUG += '[---]' + '\n'
            DEBUG += "  Contenu de res_voip_config :\n"
            DEBUG += var_filter(str(res_voip_config)) + "\n\n"
            DEBUG += "  Contenu de trunks_list :\n"
            DEBUG += var_filter(str(trunks_list)) + "\n\n"
            DEBUG += '[---]' + '\n'
            DEBUG += "  Contenu de WifiData :\n"
            DEBUG += var_filter(str(WifiData)) + "\n\n"
            DEBUG += "  Contenu de WifiCom :\n"
            DEBUG += var_filter(str(WifiCom)) + "\n\n"
            DEBUG += '[---]' + '\n'
            DEBUG += "  Contenu de dslstats :\n"
            DEBUG += var_filter(str(dslstats)) + "\n\n"
            DEBUG += "  Contenu de DslMibs :\n"
            DEBUG += var_filter(str(DslMibs)) + "\n\n"
            
            if FlagH != 'oui':
                DEBUG = Result_Header + DEBUG
            self.notebook.add(self.frame_DEBUG)
            self.text_DEBUG.config(state=NORMAL)
            self.text_DEBUG.delete('1.0', END)
            self.text_DEBUG.insert(INSERT, "[" + quoting + "]\n" + DEBUG)
            self.text_DEBUG.insert(INSERT, "[/" + quoting + "]")
            self.text_DEBUG.config(state=DISABLED)
            
        ## Déconnexion
        lb.logout()
        


if __name__ == '__main__':
    interface = Interface()
    sys.exit(0)
